// Lesson 10 - lesson10EconPointTest.js

/* 
* An econPoint object encapsulates (i.e. "has a" ) 
*   x-coordinate representing the quantity of an item
* and has the following method defined:
*   isEqualQuantity(otherQ) // determines if this quantity is same as another quantity
*/

// Good programming practice includes following
// strict programming guidelines.
"use strict"

/** The main test suite starts here. */
function myMainTestMethod() {
    myEconPointTest();
    myEconPointArrayTest();

}

/** Test the various features of the EconPointClass*/
function myEconPointTest() {
	console.log("");
	console.log("BEGINNING EconPointClass TEST");

	var myPoint1 = new EconPointClass(3,3);
	var myPoint2 = new EconPointClass(0,0);
	var myPoint3 = new EconPointClass(0.101, 0.0999);

	// Calling the EconPointClass's toString() method
	console.log("...testing myPoint1's toString(): "+myPoint1.toString()); 
	console.log("...testing myPoint2's toString(): "+myPoint2.toString()); 

	// testing the isEqualPrice() method, this return a boolean (true)
	console.log("...testing myPoint1.isEqualPrice(3,3) = "+myPoint1.isEqualPrice(3,3));

	// testing the isEqual...() Tolerance
	console.log("...Testing 0.099 < EconPointClass.TOLERANCE) = "+myPoint3.isEqualPrice(myPoint2.price));
	console.log("...Testing 0.101 < EconPointClass.TOLERANCE) = "+myPoint3.isEqualQuantity(myPoint2.quantity));

	// testing the isEqualQuantity() by using the instance field as a parameter
	// NOTE: "private" fields do not exist in JavaScript as they do in Java
	// and has security implications addressed in a later lesson
	console.log("...testing myPoint1.isEqualQuantity(myPoint3.quantity) = "+myPoint1.isEqualQuantity(myPoint3.quantity)); // false 

	// While the object seems to be a EconPointClass, the default inherited toString() 
	// comes from JavaScript's Object type.  In other words, overridden/overloaded methods
	// should be called explicitly rather than implictly as in Java
	console.log(myPoint2);

	// However, when concatenated with Strings, the object hierarchy [prototype chaining]
	// may act like a Java's autoboxing/unboxing.
	console.log("...testing the prototype chain for myPoint2: "+myPoint2);			

	console.log("ENDING EconPointClass TEST");
	console.log("");
}

/** Test and return an array of ten (quantity, price) points. */
function myEconPointArrayTest() {

	console.log("");
	console.log("BEGINNING EconPointArray TEST");

	var econPointArray = new Array();
	for (var i=0; i<10; i++)
	{
		econPointArray[i] = new EconPointClass(i,i);
	}

	console.log("..."+econPointArray);

	console.log("ENDING EconPointArray TEST");
	console.log("");
	return econPointArray;
}
