// Lesson 10  - lesson10ModifyDOM.js

// Good programming practice includes following
// strict programming guidelines.
"use strict"

function myMainMethod() {

	// 1. Instantiate a new EconPointClass object.
	var econPoint = new EconPointClass(10,10);
	
	// 2. Get all the <TD> elements of all tables, 
	// ignore the first two (which are column headings on the first table), and 
	// set its text to "1."
	var tdIndex = document.getElementsByTagName("TD");
	tdIndex[2].innerHTML = "1";
	
	// 3.Get the <TD id="econPointID"> element and
	// set its text to the new EconPointClass object.
	var tdEconPoint = document.getElementById("econPointID");
	tdEconPoint.innerHTML = econPoint.toString();
}

/*
* The myAddEconPointsToTableData() method accesses a table (or creates one) in the document 
* with a <TABLE name="dynamicTableName"> tag.  It then instantiates an array and 
* populates the array with ten EconPontClass objects.  The necessary rows and data elements
* are created and added to the table.
*/
function myAddEconPointsToTableData() {
	
	// 1. Get the table row element which contains an array of TD elements.
	var myTables = document.getElementsByName("dynamicTableName");
	var myTable = myTables[0]; // access the only table with the dynamicTableName

	// 2. If the table does not exist, create it and add to the document body.
	if (myTable == null) {
		myTable = document.createElement("TABLE");
		myTable.setAttribute("name", "dynamicTableName");
		document.body.appendChild(myTable);
	}
	
	// 3. Create an array of ten new EconPointClass objects
	var myEconPointArray = new Array();
	for (var i=0; i<10; i++)
	{
		// use a linear model to represent the negotiation points: y = m*(x - 0) + 0 
		var x = i;  // assume price's x-coordinate is the same as the index
		var m = 2;  // assume a slope of 2 for the price increases
		var y = m*(x-0) + 0;
		
		myEconPointArray[i] = new EconPointClass(x,y);
	}
	
	// 4. In a loop for each point in the array,
	// create a table row with two data elements,
	// add the appropriate index and points to the data elements,
	// add the data elements to the row, and finally 
	// add the new row to the table.
	for (var i=0; i<myEconPointArray.length; i++) {
		var myTableRow = document.createElement("TR");
		var myRowData1 = document.createElement("TD");
		var myRowData2 = document.createElement("TD");
		
		myRowData1.innerHTML = i;
		myRowData2.innerHTML = myEconPointArray[i].toString();
		
		myTableRow.appendChild(myRowData1);
		myTableRow.appendChild(myRowData2);
		
		myTable.appendChild(myTableRow);
	}
}
