// Lesson 11

// good programming practice includes following
// strict programming guidelines
"use strict"

/* 
* The .saveCookie() method saves the User Name and Password in
* a cookie.  If successful, it displays an alert with information stored.
* If cookies are not enabled in the browser it will give an alert.
* NOTE: This demonstrates that passwords are NOT encrypted by the browser.
*/
function setCookie() {
	var ce = navigator.cookieEnabled;
	if (ce == false) {
		alert("cookies are not enabled...cannot save");
	}
	else {
		var userName = document.getElementById("userNameID").value;
		var userPassword = document.getElementById("userPasswordID").value;
		
		// Store cookie as name=value pair.  Must also avoid special characters
		// such as semicolons, commas, and spaces by using the built in
		// encodeURIComponent() method.
		var cookie1 = "user="+encodeURIComponent(userName);
		var cookie2 = "password="+encodeURIComponent(userPassword);
		
		// Get today's date and set the expiration time to 
		// 15 seconds from now (15 * 1000 milliseconds).
		var d = new Date();
		d.setTime(d.getTime() + 15*1000);
		var expires = "expires="+d.toUTCString();
		
		// This will add or append the cookie to the documents local storage.
		// Also the username cookie will expire in 10 seconds.
		document.cookie=cookie1 + ";" + expires;
		document.cookie=cookie2;
		
		alert("Saved " + userName + " with password = "+userPassword);
	}
}

/*
* This method gets a list of all the cookies, creates a line-by-line
* string of name=value pairs and prints them in an alert()
*/
function seeAllCookies() {
	var cookieList = getAllCookies();
	var text = "";
	for (var cookieX in cookieList) {
		text += cookieX + "=" + cookieList[cookieX] + '\n';
	}
	alert (text);
}

/*
* Get all the cookies in a list then 
* set each setting a blank value and max-age attribute to 0.
*/
function clearCookies() {
	var cookieList = getAllCookies();
	
	// Get today's date and set the expiration time to now.
	var d = new Date();
	d.setTime(d.getTime());
	var expiresNow = "expires="+d.toUTCString();
	
	for (var cookieX in cookieList) {
		var cookieDelete = cookieX + "=";
		cookieDelete += ";" + expiresNow;
		document.cookie=cookieDelete;
	}
	// Access the <div> tag (i.e. iFrame) in the document and set its style
	// so that it becomes visible.
	document.getElementById("iFrameID").setAttribute("style","display:none");	
}

/*
* This will verify if the user typed in the word "PASSWORD" into th User Password
* text box.  If so, then change the iFrame to be visible within the document.
*/
function checkPasswordCookie() {
	
	// Call the method to decode all the cookies in the document.
	var cookieList = getAllCookies();
	if ((cookieList["password"] === null) || (cookieList["password"] != "PASSWORD")) {
		alert("try typing PASSWORD into the correct text box and press 'Remember Me!'");
	}
	else {
		// Access the <div> tag (i.e. iFrame) in the document and set its style
		// so that it becomes visible.
		document.getElementById("iFrameID").setAttribute("style","display:visible");
	}
}

/* 
* This method returns a list of all the cookies in the browser based on the name.
*/
function getAllCookies() {
	var cookiesList = {};
	
	// All cookies in the document.
	var ac = document.cookie;
	
	// If no cookies exist then return.
	if (ac == "") return cookiesList;
	
	// Separate all cookies into individual cookies in a list.
	var clist = ac.split("; ");    
	for (var i=0; i<clist.length; i++) {
		var oneCookie = clist[i];

		// Find the index of the equal sign.
		var eq = oneCookie.indexOf("="); 
				
		// First part is the cookie name.
		var name = oneCookie.substring(0,eq); 
		
		//  After the equals is the cookie value. 
		var value = oneCookie.substring(eq+1);
		
		// Decode the value and store in the list.
		value = decodeURIComponent(value);
		cookiesList[name] = value;
	};
	return cookiesList;
	
}
