// Lesson 5, JavaScript and the Document Object Model  NO COMMENT VERSION

"use strict"

var currentState;	
var userInterface;	

function myMainMethod() {init();}

function init(newShade) {
	userInterface =  {
		headingIdRed: 	null,
		promptIdRed:	null,
		inputIdRed: 	null,
		percentIdRed: 	null,
		numberIdRed:	null,
		lowIdRed: 	null,
		highIdRed: 	null
	};
	for (var id in userInterface) {
		userInterface[id] = document.getElementById(id);  
	}
	currentState = {
		valueRed: 		Math.floor(Math.random()*100)+1,  	
		numberOfTriesRed: 	0,				
		previousRed: 		undefined				
	};
	userInterface.inputIdRed.onchange = handleNewRedShade;	
	window.onpopstate = getHistoryState;
	modifyWebPage(currentState);
}

function setHistory(oldState) {
	if (!history.pushState) {
		alert ("cannot push to the history object");
		return; 
	}
	var url = "#previous" + oldState.previousRed;
	history.pushState(oldState, "", url);
}

function getHistoryState(event) {
	if (event.state != null) {
		currentState = event.state;
		modifyWebPage(currentState);
	}
	else {
		history.replaceState(currentState, "", "#previous" + currentState.previousRed);
	}
}

function handleNewRedShade() {
	var value = parseInt(this.value); 	
		
	if ((value > 0) && (value <= 100)) {
		currentState.previousRed = currentState.valueRed;
		currentState.valueRed = value;
		currentState.numberOfTriesRed++;
		setHistory(currentState);
		modifyWebPage(currentState);
	}
	else {
		alert("Please enter a number between 0 and 100"); 
	}
}

function modifyWebPage(newState) {
	document.title = "Try a shade between 0 and 100";  	
	userInterface.headingIdRed.innerHTML = document.title; 
	userInterface.percentIdRed.innerHTML = "Red at " + newState.valueRed +" %";
	userInterface.numberIdRed.innerHTML  = "Number of red shades attempted: "+newState.numberOfTriesRed;	
	
	var byteColorRed = new Number(newState.valueRed/100.0 * 255);
	byteColorRed = byteColorRed.toFixed(0); 
	userInterface.lowIdRed.style = "background-color:rgb("+byteColorRed+",0,0)";
	userInterface.lowIdRed.style.width = newState.valueRed +"%";
	userInterface.highIdRed.style.width = (100-newState.valueRed) + "%";
	userInterface.inputIdRed.value = "";
	userInterface.inputIdRed.focus();
	if (newState.previousRed === undefined) {
		userInterface.promptIdRed.innerHTML = "Type in a shade of RED and hit Enter";
	}
	else if (newState.previousRed > 100) {
		userInterface.promptIdRed.innerHTML = "too high, try a number less than  or equal to 100";
	}
	else if (newState.previousRed < 0) {
		userInterface.promptIdRed.innerHTML = "too low, try a number greater than 0";
	}
	else {
		userInterface.promptIdRed.innerHTML = "Enter a new shade of RED";
	}
}

	
