// Lesson 8, Debugging Solution

// Good programming practice includes following strict programming guidelines
// "use strict" also helps find Syntax Errors that would otherwise fail silently
"use strict"

function swapImages() {

	// No errors to get the first image from the DOM	
	var firstImage  = window.document.getElementById("AceClubs");

	/* Error Type 1: JavaScript SYNTAX ERROR, forgetting an assignment (=).
	* 		 Console error message will "assume" that there is a missing semicolon (;)
	* 		 after declaration of the secondImage variable.
	*  DEBUG BY COMMENTING OUT THE NEXT LINE
	*/
	//var secondImage   window.document.getElementById("twoClubs");

	// Error Type 1: Correct Syntax 
	var secondImage = window.document.getElementById("twoClubs");

	
	/* Error Type 2: JavaScript RUNTIME ERROR, misspelling a function name.
	*		 May generate a Console Error for a generic "TypeError"
	*		 May generate a Debugger Error where an Exception variable can be inspected.
	*		 Often caused by trying to access an object (method/property)
	*		 that does not exist in the DOM.
	*  DEBUG BY COMMENTING OUT THE NEXT LINE
	*/
	//var thirdImage 	= window.document.getElementByID("threeClubs");
	
	// Error Type 2: Correct RunTime method call 
	var thirdImage 	= window.document.getElementById("threeClubs");


	/* Error Type 3: JavaScript LOGIC ERROR, not swapping the intended images.
	*		 No Console messages but the X/HTML does not display 
	*		 swapped/rotated images as expected.  Instead, it duplicates
	*		 one of the images.
	*  DEBUG BY COMMENTING OUT THE NEXT 3 LINES
	*/
	//firstImage.src  = secondImage.src;
	//secondImage.src = thirdImage.src
	//thirdImage.src 	= firstImage.src;

	// Error Type 3: Correct logic to swap to rotate the images 	
	var temp 	= thirdImage.src;
	thirdImage.src 	= secondImage.src;
	secondImage.src = firstImage.src
	firstImage.src 	= temp;

	// Define or call the following method to change the DOM
	// so that it swaps/rotates the paragraph text to be consistent
	// with the card images.
	swapText();

}

function swapText() {

	var firstText = document.getElementById("slot0");
	var secondText = document.getElementById("slot1");
	var thirdText = document.getElementById("slot2");

	var temp 		= thirdText.innerHTML;
	thirdText.innerHTML 	= secondText.innerHTML;
	secondText.innerHTML	= firstText.innerHTML;
	firstText.innerHTML 	= temp;

}


