// Lesson 9, Part 1, Sequence A

// good programming practice includes following
// strict programming guidelines
"use strict"

function myMainMethod() {

	// 1. Declare a variable called "myFormObject" to refer to the form object 
	// (i.e. <FORM> </FORM> tag) created by the built-in createElement() 
	// method as exists within the document object (i.e. <HTML>...</HTML>).
	// NOTE: createElement() method is built into the browser's JavaScript engine.
	var myFormObject = document.createElement("FORM");
	
	// 2. Define a button object (i.e. <BUTTON> ... </BUTTON>) and 
	// assign it to the myButtonInForm variable.
	var myButtonInForm = document.createElement("BUTTON");

	// 3. Define some text to display as text on the <BUTTON>.
	// NOTE: createTextNode() method is built into the browser's JavaScript engine. 
	var myButtonText = document.createTextNode("Submit Form Button");

	// 4. Add the text to the <BUTTON> object as a label. 
	// (i.e. <BUTTON> Submit Form Button </BUTTON>)
	myButtonInForm.appendChild(myButtonText);
	
	// 5. Add the <BUTTON> form Button 1 </BUTTON> tag to the <FORM> tag.
	myFormObject.appendChild(myButtonInForm);
	
	// 6. Using  step 1's myFormObject, we add the <FORM> </FORM> tag 
	// to the document's <BODY>...</BODY> tag
	// this form will be attached to the the DOM as a new  object.
	document.body.appendChild(myFormObject);

	/* 7. DEBUGGING: The following two statements demonstrate that the button 
	* object has been created in the new form and that the form has been added 
	* to the document's DOM.  Just uncomment (i.e. remove //) to test.
	* 
	* The first alert() method accesses the DOM directly. 
	* Theoretically, a document can hold more than one form
	* so we just access the first form using array notation at index [0].
	* the innerHTML just displays the <BUTTON>...</BUTTON> tag.	
	*/

	window.alert("added "+ document.forms[0].innerHTML);

	/* The second alert() method is slightly more complicated in that it calls the 		
	* getElementsByTagName() method to obtain the form object.It should give the
	* exact same results as the above alert() method.
	*/

	 //window.alert("added "+ document.getElementsByTagName("form")[0].innerHTML);
	
}
