// Lesson 9 Part 1, Sequence B, Solution

// good programming practice includes following
// strict guidelines
"use strict"

function myMainMethod() {

	// 1. call the myAddRadio() method declared below
	myAddRadio();
	
	// 2. call the myAddTextArea() method declared below
	myAddTextArea();
	
	// 3. call the myAddButton() method declared below
	myAddButton();

	// STUDENT SOLUTION to calling their myAddText()
	myAddText();
}

/* STUDENT SOLUTION to adding a <INPUT type="text"> </INPUT> tag.  */
function myAddText()
{
	var myFormObject 	= document.createElement("FORM");
	var myP			= document.createElement("P");
	var myInputToForm	= document.createElement("INPUT");

	myInputToForm.setAttribute("type", "text");
	myP.appendChild(myInputToForm);
	myFormObject.appendChild(myP);
	document.body.appendChild(myFormObject);	
}


/*
* The myAddTextArea() method simply creates form and textArea objects and 
* assembles them together before adding to the document body.
* The resulting HTML (DOM) code segment should look like:
* <FORM>
* 	<TEXTAREA> </TEXTAREA>
* </FORM>
*/
function myAddTextArea()
{
	// 1. construct a 2nd "myFormObject"
	var myFormObject = document.createElement("FORM");
	
	// 2. define a <TEXTAREA> object
	var myTextAreaInForm = document.createElement("TEXTAREA");
	
	// 3. add the textArea to the form
	myFormObject.appendChild(myTextAreaInForm);
	
	// 4. add the form to document body
	document.body.appendChild(myFormObject);
	
}

/*
* The myAddButton() method is equivalent to Lesson1 Part 1's myForm() method. 
* The resulting HTML (DOM) code segment should look like:
* <FORM>
* 	<BUTTON> Submit Form </BUTTON>
* </FORM>
*/
function myAddButton() {
	
	// 1. construct a 3rd "myFormObject" 
	var myFormObject = document.createElement("FORM");
	
	// 2. define a <BUTTON> ... </BUTTON> object
	var myButtonInForm = document.createElement("BUTTON");

	// 3. define some text to display as text on the <BUTTON> 
	var myButtonText = document.createTextNode("Submit Form");

	// 4. add the text to the <BUTTON> object as a label 
	myButtonInForm.appendChild(myButtonText);
	
	// 5. add the <BUTTON> form Button 1 </BUTTON> tag to the <FORM> tag
	myFormObject.appendChild(myButtonInForm);
	
	// 6. add the button to the <FORM> </FORM> tag 
	document.body.appendChild(myFormObject);
}

/*
* The myAddRadio() method is similar to Lesson1 Part 1a's myMainMethod().
* However, instead of adding a button object, this method creates a new form object
* then adds two radio input elements to the new form.   
* The resulting HTML (DOM) code segment should look like:
* <FORM>
*		<P> <INPUT type="radio" value="apple"> apple </INPUT></P>
*		<P> <INPUT type="radio" value="oranges"> oranges </INPUT></P>
* </FORM>
*/
function myAddRadio() {
	
	// 1. construct a "myFormObject".  Note that this is a different variable than
	// used in myAddButton() method since the "var" keyword creates a scoped variable
	// that exists only in the myAddRadio() method
	var myFormObject = document.createElement("FORM");
	
	// 2. create the <P> <INPUT type="radio" value="apple"> apple </INPUT></P>
	//    by defining the <P>, <INPUT>, and text objects. 
	//    then set the appropriate attributes of the <INPUT> object
	//    add the <INPUT> object as a child of the <P> object
	//    add the text to the <P> object
	//    add the <P> object as a child to the <FORM> object
	var myP				= document.createElement("P");
	var myInputToForm		= document.createElement("INPUT");
	var myPtext			= document.createTextNode("apples");
	myInputToForm.setAttribute("type", "radio");
	myInputToForm.setAttribute("value", "apples");
	myP.appendChild(myInputToForm);
	myP.appendChild(myPtext);
	myFormObject.appendChild(myP);

	// 3. repeat for 2nd radio button to create
	//    <P> <INPUT type="radio" value="oranges"> oranges </INPUT></P>
	var myP2		= document.createElement("P");
	var myInputToForm2	= document.createElement("INPUT");
	var myPtext2		= document.createTextNode("oranges");
	myInputToForm2.setAttribute("type", "radio");
	myInputToForm2.setAttribute("value", "oranges");
	myP2.appendChild(myInputToForm2);
	myP2.appendChild(myPtext2);
	myFormObject.appendChild(myP2);
	
	// 4. add the button to the <FORM> </FORM> tag 
	document.body.appendChild(myFormObject);	
}

