// Lesson 9, Part 2 Solution

// good programming practice includes following
// strict programming guidelines
"use strict"

function myMainMethod() {

	// 1. Get the text values from the select objets options.
	// NOTE: We assume that the <SELECT id="selectID"> tag exists
	var myOptionsArray = document.getElementById("selectID");
	var ascendingRadio = document.getElementById("ascending");;

	// 2. Get the text from each option and store in a new Array to be sorted.
	var optionTextArray = new Array();
	for(var i=0; i<myOptionsArray.length; i++)  {
		 optionTextArray[i] = myOptionsArray.options[i].text;
	}

	// 3. Determine which radio button (ascending or descending) was clicked
	if (ascendingRadio.checked){
		
		// Sort the array by ascending text using the 
		// SELECTION SORT ALGORITHM defined below.
		mySelectionSortAscending(optionTextArray);
	}
	else {  // the descending radio button was clicked
		// THE STUDENT MAY DEFINE AND CALL THEIR OWN SORT FUNCTION 
		mySelectionSortDescending(optionTextArray);
	}
	// 4. Set each option's text and value to the sorted text and value.
	for(var i=0; i<myOptionsArray.length; i++)  {
  		myOptionsArray.options[i].text = optionTextArray[i];
  		myOptionsArray.options[i].value = optionTextArray[i];
	}
}

/* The mySelectionSortAscending() method scans through the array to find the
* minimum value, it then swaps the minimum with the first value of the array.
* It then scans for the second smallest value of remainder of array and swaps
* that value with the 2nd value of the array.  The process continues until
* each "smallest" value has been selected and swapped toward the front of
* the array. */
function mySelectionSortAscending(a)
{
	// set all values to index = 0 and start of array values
	var sortedIndex		= 0;
	var minIndex		= 0;
	var currentMinValue	= a[0];
 
	/* 
	* Start the minimum array value at minIndex=0 then advance the sortedIndex 
	* so the next smallest value is stored at sortedIndex=1, 3rd smallest at index=2
	* and so on until we've sorted through the entire array.
	*/
	for (sortedIndex = 0; sortedIndex < a.length-1; sortedIndex++) {

		/*
		* Start the search for the next minimum value at the index 
		* AFTER the already sortedIndex.
		*/
		minIndex = sortedIndex;
		
		/*
		*  Now, scan through each index of the array to find the ACTUAL 
		* next minimum value
		*/
		for (var scanIndex = sortedIndex+1; scanIndex < a.length; scanIndex++) {
			
			/*if value at scanned index is less than value at the current minimum*/  
			if (a[scanIndex] < a[minIndex]) {

				/*
				* Then we have found new minimum so REMEMBER that the index of
				* the new minimum value
				*/
				minIndex = scanIndex;
			}
		}
 
 		/*
		* If the minimum has not already been sorted, then swap the minimum 
		* value of the remainder of the unsorted array with value at the
		* beginning of the unsorted section of the array.
		*/
		if(minIndex != sortedIndex) {
			var temp;
			temp			= a[sortedIndex];
			a[sortedIndex]		= a[minIndex]
			a[minIndex]		= temp;
		}
	}
}


function mySelectionSortDescending(a)
{
	var sortedIndex		= 0;
	var maxIndex		= 0;

	for (sortedIndex = 0; sortedIndex < a.length-1; sortedIndex++) {

		maxIndex = sortedIndex;

		for (var scanIndex = sortedIndex+1; scanIndex < a.length; scanIndex++) {	
			if (a[scanIndex] > a[maxIndex]) {
				maxIndex = scanIndex;
			}
		}

		if(maxIndex != sortedIndex) {
			var temp;
			temp			= a[sortedIndex];
			a[sortedIndex]		= a[maxIndex]
			a[maxIndex]		= temp;
		}
	}
}


